/*
  Copyright <2018-2025> <scott.e.graves@protonmail.com>

  Permission is hereby granted, free of charge, to any person obtaining a copy
  of this software and associated documentation files (the "Software"), to deal
  in the Software without restriction, including without limitation the rights
  to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  copies of the Software, and to permit persons to whom the Software is
  furnished to do so, subject to the following conditions:

  The above copyright notice and this permission notice shall be included in all
  copies or substantial portions of the Software.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  SOFTWARE.
*/
#include "usage_cmd.hpp"

#include "utils/error.hpp"

namespace monitarr {
auto usage_cmd() -> int {
  MONITARR_USES_FUNCTION_NAME();

  utils::error::handle_info(
      function_name,
      "\n\nusage:\n"
      "  monitarr -b -i <index> -id <record id>\n"
      "    blocklist and search record id at configuration index\n"
      "  monitarr -c\n"
      "    display configuration\n"
      "  monitarr -h\n"
      "    display help\n"
      "  monitarr -l -i <index>\n"
      "    display server queue at configuration index\n"
      "  monitarr -r\n"
      "    run monitarr server\n"
      "  monitarr -s -i <index> -id <record id>\n"
      "    show record id details at configuration index\n"
      "  monitarr -t\n"
      "    test all server connectivity\n");

  return 0;
}
} // namespace monitarr
